# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/03_cli.ipynb.

# %% auto 0
__all__ = ['render']

# %% ../nbs/03_cli.ipynb 2
from pathlib import Path
from .core import Data
from .loaders import xml_file_to_data
from .codegen import Sal, FrontMatterInMemoryTemplateLoader, Renderer, JinjaTemplateRenderer, MissingTemplate

# %% ../nbs/03_cli.ipynb 5
def render(file, templates):
    try:
        repository = FrontMatterInMemoryTemplateLoader.from_directory(templates)
        renderer = Renderer(repository=repository, renderer=JinjaTemplateRenderer())
        sal = Sal(renderer)

        struct: Data = xml_file_to_data(file)  
        return sal.process(struct)
    except MissingTemplate as e:
        path = Path(templates) / f"{e.name}.jinja2"
        path.write_text(Renderer.DEFAULT_TEMPLATE)
        return render(file, templates)
